<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<style>
			.node circle {
			stroke: white;
			stroke-width: 1.5px;
			opacity: 0.9;
			}

			.node text {
			pointer-events: none;
			font: sans-serif;
			}

			line {
			stroke: #ccc;
			stroke-width: 1.0px;
			stroke-opacity: 0.1;
			}

			table {
			width: 100%; 
    			margin: 0 auto; /* or margin: 0 auto 0 auto */
  			}

			tbody td{
  			padding: 2px;
			font-family: sans-serif; 
			font-size: 10px; 
			}

			tbody tr:nth-child(odd){
  			background-color: #66ccff;
  			color: #FFFFFF;
			}
			tbody tr:nth-child(even){
  			background-color: #eff0f2;
  			color: Black;
			}

			.footer {
  			position: absolute;
  			right: 0;
  			bottom: 0;
  			left: 10px;
  			padding: 3px;
  			background-color: #ffffff;
  			text-align: left;
			}

			.ui-autocomplete {
    			position: absolute;
    			cursor: default;
    			height: 200px;
  			font-size: 14px; 
    			overflow-y: scroll;
    			overflow-x: hidden;}

		</style>
	</head>

	<script src="https://d3js.org/d3.v3.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.0/jquery.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
	<link rel="stylesheet" type="text/css" href="jquery-ui-edited.css">

	<body>
		<div	id='divSearch' 
			style='position:absolute;top:0px;  
			Padding-Left:10px; Padding-Right:10px;Padding-Top:5px;Padding-Bottom:5px;
			Text-Align:left;background-color:#ffffff'>
			<p align=left>
				<input id="inpTxtTargetNode" name="inpTxtTargetNode" type="text" size=30 onkeydown="if (event.keyCode == 13) displayTarget()"/>
				<button id="searchBtn" type="button" type="submit" size=15 onclick="displayTarget()">Search</button>
				<button id="searchBtn" type="button" type="submit" width=15 onclick="startReset()">Reset</button>
			</p>

		</div>

		<div	id='divSynopsis' 
			style='position:absolute;top:25px;Height:680px;left:75%;Width:300px;visibility:hidden;  
			Padding-Left:10px; Padding-Right:10px;Padding-Top:5px;Padding-Bottom:5px;
			Border-Top:#C0C0C0 1px solid;Border-Left:#C0C0C0 1px solid;Border-Bottom:#C0C0C0 3px solid;Border-Right:Black 3px solid;
			Text-Align:left;background-color:#ffffff'>

		</div>

		<script>
	
			/*++++++++++++++++++
			 + Load color scale
			 ++++++++++++++++++*/

			var c10 = d3.scale.category10();

			var data = {
				nodes: [ 

					/*++++++++++++++++++++++++++++ 
					 + The Bank of America Cluster 
					 +++++++++++++++++++++++++++++*/
 
					{ id:  0, name: "Bank of America Corp.", size: 89.7, tooltip: "NYSE:BAC" },
					{ id:  1, name: "Adobe Systems Inc.", size: 7.3, tooltip: "NASDAQ:ADBE" },
					{ id:  2, name: "Akamai Technologies Inc.", size: 2.5, tooltip: "NASDAQ:AKAM" },
					{ id:  3, name: "Amazon.com Inc.", size: 136, tooltip: "NASDAQ:AMZN" },
					{ id:  4, name: "AppRiver LLC", size: 0.075, tooltip: "NONE" },
					{ id:  5, name: "Automattic Inc.", size: 0.05, tooltip: "NONE" },
					{ id:  6, name: "Barracuda Networks Inc.", size: 0.38, tooltip: "NYSE:CUDA" },
					{ id:  7, name: "CenturyLink Inc.", size: 18, tooltip: "NYSE:CTL" },
					{ id:  8, name: "CSC Inc.", size: 1, tooltip: "NONE" },
					{ id:  9, name: "DigiCert Inc.", size: 0.1, tooltip: "NONE" },
					{ id: 10, name: "Dyn Inc.", size: 0.1, tooltip: "NONE" },
					{ id: 11, name: "Dynatrace LLC", size: 1, tooltip: "NONE" },
					{ id: 12, name: "Entrust Datacard Corp.", size: 1, tooltip: "NONE" },
					{ id: 13, name: "GoDaddy Inc.", size: 2, tooltip: "NYSE:GDDY" },
					{ id: 14, name: "Microsoft Corp.", size: 90, tooltip: "NASDAQ:MSFT" },
					{ id: 15, name: "NeuStar Inc.", size: 1.5, tooltip: "NONE" },
					{ id: 16, name: "New Dream Network LLC", size: 0.05, tooltip: "NONE" },
					{ id: 17, name: "New Relic Inc.", size: 0.2, tooltip: "NYSE:NEWR" },
					{ id: 18, name: "Proofpoint Inc.", size: 0.4, tooltip: "NASDAQ:PFPT" },
					{ id: 19, name: "Sitecore A/S", size: 0.1, tooltip: "NONE" },
					{ id: 20, name: "Squarespace Inc.", size: 0.5, tooltip: "NONE" },
					{ id: 21, name: "Symantec Corp.", size: 4, tooltip: "NASDAQ:SYMC" },
					{ id: 22, name: "Verizon Communications Inc.", size: 126, tooltip: "NYSE:VZ" },

					/*+++++++++++++++++++++++++++++++ 
					 + The Cisco Systems Inc. Cluster 
					 ++++++++++++++++++++++++++++++++*/
 
					{ id: 23, name: "Cisco Systems Inc.", size: 48, tooltip: "NASDAQ:CSCO" },
					{ id: 24, name: "Alphabet Inc.", size: 92, tooltip: "NASDAQ:GOOGL" },
					{ id: 25, name: "AppDynamics Inc.", size: 0.25, tooltip: "NONE" },
					{ id: 26, name: "CloudFlare Inc.", size: 0.5, tooltip: "NONE" },
					{ id: 27, name: "Comodo Group Inc.", size: 0.05, tooltip: "NONE" },
					{ id: 28, name: "NetSuite Inc.", size: 0.9, tooltip: "NONE" },
					{ id: 29, name: "Optimizely Inc.", size: 0.1, tooltip: "NONE" },
					{ id: 30, name: "Rackspace Inc.", size: 2.5, tooltip: "NONE" },
					{ id: 31, name: "Salesforce.com Inc.", size: 8.5, tooltip: "NYSE:CRM" },
 
					/*+++++++++++++++++++++++++++ 
					 + The Ford Motor Co. Cluster 
					 ++++++++++++++++++++++++++++*/
 
					{ id: 32, name: "Ford Motor Co.", size: 155, tooltip: "NYSE:F" },
					{ id: 33, name: "Deutsche Telekom AG", size: 80, tooltip: "ETR:DTE" },
					{ id: 34, name: "F5 Networks Inc.", size: 2.5, tooltip: "NASDAQ:FFIV" },
					{ id: 35, name: "Level 3 Communications Inc.", size: 10, tooltip: "NYSE:LVLT" },
					{ id: 36, name: "Raytheon Co.", size: 25, tooltip: "NYSE:RTN" },
 
					/*++++++++++++++++++++++++ 
					 + The Pfizer Inc. Cluster 
					 +++++++++++++++++++++++++*/
 
					{ id: 37, name: "Pfizer Inc.", size: 55, tooltip: "NYSE:PFE" },
					{ id: 38, name: "Imperva Inc.", size: 0.3, tooltip: "NASDAQ:IMPV" },
 
					/*+++++++++++++++++++++++++ 
					 + The Target Corp. Cluster 
					 ++++++++++++++++++++++++++*/
 
					{ id: 39, name: "Target Corp.", size: 72, tooltip: "NYSE:TGT" },
				], 

				links: [

					/*++++++++++++++++++++++++++++ 
					 + The Bank of America Cluster 
					 +++++++++++++++++++++++++++++*/
 
				 	{ source: 0, target: 1, label: "CMS" }, 
				 	{ source: 0, target: 1, label: "OTP" }, 
				 	{ source: 0, target: 2, label: "WPM" },
				 	{ source: 0, target: 3, label: "DNS" },
				 	{ source: 0, target: 3, label: "Cloud Platform" },
				 	{ source: 0, target: 4, label: "Security" },
				 	{ source: 0, target: 5, label: "CMS" },
				 	{ source: 0, target: 6, label: "Security" },
				 	{ source: 0, target: 7, label: "ISP" },
				 	{ source: 0, target: 8, label: "DNS" },
				 	{ source: 0, target: 9, label: "SSL Certificates" },
				 	{ source: 0, target: 10, label: "DNS" },
				 	{ source: 0, target: 11, label: "WPM" },
				 	{ source: 0, target: 12, label: "SSL Certificates" },
				 	{ source: 0, target: 13, label: "SSL Certificates" },
				 	{ source: 0, target: 14, label: "Cloud Platform" },
				 	{ source: 0, target: 15, label: "DNS" },
				 	{ source: 0, target: 16, label: "Hosting" },
				 	{ source: 0, target: 17, label: "WPM" },
				 	{ source: 0, target: 18, label: "Security" },
				 	{ source: 0, target: 19, label: "CMS" },
				 	{ source: 0, target: 20, label: "CMS" },
				 	{ source: 0, target: 21, label: "Security" },
				 	{ source: 0, target: 22, label: "ISP" },

					/*+++++++++++++++++++++++++++++++ 
					 + The Cisco Systems Inc. Cluster 
					 ++++++++++++++++++++++++++++++++*/

				 	{ source: 23, target: 1, label: "CMS" }, 
				 	{ source: 23, target: 1, label: "OTP" }, 
				 	{ source: 23, target: 2, label: "WPM" }, 
				 	{ source: 23, target: 3, label: "DNS" }, 
				 	{ source: 23, target: 3, label: "Cloud Platform" }, 
				 	{ source: 23, target: 5, label: "CMS" },
				 	{ source: 23, target: 7, label: "Hosting" },
				 	{ source: 23, target: 9, label: "SSL Certificates" },
				 	{ source: 23, target: 13, label: "SSL Certificates" },
				 	{ source: 23, target: 14, label: "Hosting" },
				 	{ source: 23, target: 17, label: "WPM" },
				 	{ source: 23, target: 24, label: "Cloud Platform" }, 
				 	{ source: 23, target: 25, label: "WPM" }, 
				 	{ source: 23, target: 26, label: "Security" },
				 	{ source: 23, target: 27, label: "SSL Certificates" },
				 	{ source: 23, target: 28, label: "CRM" },
				 	{ source: 23, target: 29, label: "OTP" },
				 	{ source: 23, target: 30, label: "Cloud Platform" },
				 	{ source: 23, target: 31, label: "CMS" },

					/*+++++++++++++++++++++++++++ 
					 + The Ford Motor Co. Cluster 
					 ++++++++++++++++++++++++++++*/
 
				 	{ source: 32, target: 1, label: "CMS" }, 
				 	{ source: 32, target: 1, label: "OTP" }, 
				 	{ source: 32, target: 2, label: "WPM" }, 
				 	{ source: 32, target: 5, label: "CMS" },
				 	{ source: 32, target: 14, label: "CMS" },
				 	{ source: 32, target: 18, label: "Security" },
				 	{ source: 32, target: 24, label: "Cloud Platform" }, 
				 	{ source: 32, target: 33, label: "ISP" },
				 	{ source: 32, target: 34, label: "Security" },
				 	{ source: 32, target: 35, label: "ISP" },
				 	{ source: 32, target: 30, label: "Cloud Platform" },
				 	{ source: 32, target: 36, label: "Security" },
 
					/*++++++++++++++++++++++++ 
					 + The Pfizer Inc. Cluster 
					 +++++++++++++++++++++++++*/
 
				 	{ source: 37, target: 1, label: "CMS" }, 
				 	{ source: 37, target: 1, label: "OTP" }, 
				 	{ source: 37, target: 3, label: "DNS" }, 
				 	{ source: 37, target: 3, label: "Cloud Platform" }, 
				 	{ source: 37, target: 5, label: "CMS" },
				 	{ source: 37, target: 10, label: "DNS" },
				 	{ source: 37, target: 12, label: "SSL Certificates" },
				 	{ source: 37, target: 14, label: "Cloud Platform" },
				 	{ source: 37, target: 17, label: "WPM" },
				 	{ source: 37, target: 18, label: "Security" },
				 	{ source: 37, target: 21, label: "Security" },
				 	{ source: 37, target: 26, label: "Security" },
				 	{ source: 37, target: 27, label: "SSL Certificates" },
				 	{ source: 37, target: 38, label: "Security" },
 
					/*+++++++++++++++++++++++++ 
					 + The Target Corp. Cluster 
					 ++++++++++++++++++++++++++*/
 
				 	{ source: 39, target: 2, label: "DNS" }, 
				 	{ source: 39, target: 2, label: "WPM" }, 
				 	{ source: 39, target: 5, label: "CMS" }, 
				 	{ source: 39, target: 8, label: "DNS" },
				 	{ source: 39, target: 9, label: "SSL Certificates" },
				 	{ source: 39, target: 14, label: "CMS" },
				 	{ source: 39, target: 18, label: "Security" },
				 	{ source: 39, target: 22, label: "ISP" },
				 	{ source: 39, target: 21, label: "Security" },
				 	{ source: 39, target: 30, label: "Cloud Platform" },
				 	{ source: 39, target: 31, label: "CMS" },
				]

			};


			/*+++++++++++++++++++
 			 + func: nodeRadius()
			 ++++++++++++++++++++*/

			function nodeRadius(d) {

				if (d.size > 100) { 
					size =  9; 
				}
				else if (d.size > 50) { 
					size =  8; 
				}
				else if (d.size > 20) { 
					size =  7; 
				}
				else if (d.size >= 1) {
					size = 6;
				}
				else{
					size = 5; 
				}

				return size; 	 
			};

			/*++++++++++++++++++
 			 + func: mouseOver()
			 +++++++++++++++++++*/

			var mouseOver = function(d) {

				var inpTargetName = document.getElementById("inpTxtTargetNode").value; 
				if (inpTargetName == ''){
					
					var circle = d3.select(this);

					node
					.transition(500)
					.style("opacity", function(o) {
					return isConnected(o, d) ? 0.9 : 0.05 ;
					});

					link
					.transition(500)
					.style("stroke-opacity", function(o) {
						return o.source === d || o.target === d ? 1 : 0.05;
					})
					.transition(500)
					.attr("marker-end", function(o) {
						return o.source === d || o.target === d ? "url(#arrowhead)" : "url()";
					});

					circle
					.transition(500)
					.attr("r", function(){ return 1.5 * nodeRadius(d)});

					
					/*+++++++++++++++++
					 + Prepare synopsis 
					 ++++++++++++++++++*/
					
					prepSynopsis(d); 	

				}

				console.log(d.name); 
			}; 


			/*+++++++++++++++++
			 + func: mouseOut()
			 ++++++++++++++++++*/

			var mouseOut = function(d) {

				var inpTargetName = document.getElementById("inpTxtTargetNode").value; 

				if (inpTargetName == ''){	
				
					var divSynopsis = document.getElementById('divSynopsis'); 
					divSynopsis.style.visibility = 'hidden';

					var circle = d3.select(this);

					node
					.transition(500) 
					.style("opacity", function(o) {
						return 0.9;
					});


					link
					.transition(500)
					.style("stroke-opacity", function(o) {
						return 0.1;
					})
					.transition(500)
					.attr("marker-end", function(o) {
						return "url()";
					});

					circle
					.transition(500)
					.attr("r", nodeRadius);
				}
			};

			/*+++++++++++++++++++
			 + func: startReset()
			 ++++++++++++++++++++*/

			function startReset(){
				
				document.getElementById("inpTxtTargetNode").value = '';
				mouseOut();   
					
			}
	

			function isConnected(a,	b) {
				return isConnectedAsTarget(a, b) || isConnectedAsSource(a, b) || a.index == b.index;
			}; 

			function isConnectedAsSource(a, b) {
				return linkedByIndex[a.index + "," + b.index];
			}; 

			function isConnectedAsTarget(a, b) {
				return linkedByIndex[b.index + "," + a.index];
			}; 

			function isEqual(a, b) {
				return a.index == b.index;
			}; 


			function tick() {

				node.attr("r", function(d){ return nodeRadius(d); })
				.attr("cx", function(d){ return d.x; })
				.attr("cy", function(d){ return d.y; });

				node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });

				link
				.attr("x1", function(d) { return d.source.x; })
				.attr("y1", function(d) { return d.source.y; })
				.attr("x2", function(d) { return d.target.x; })
				.attr("y2", function(d) { return d.target.y; });

				//Start the force layout calculation
				force.start();

			};

			/*++++++++++++++++++++++
			 + func: displayTarget()
			 +++++++++++++++++++++++*/

			function displayTarget(){

	
				var inpTargetName = document.getElementById("inpTxtTargetNode").value;

				if (inpTargetName){
					d3.selectAll('g.node').each(function(d) {

						d.fixed = false;

						if (d.name == inpTargetName){

							d.fixed = true;
							d3.selectAll('g.node')
							.transition(1000)
							.style("opacity", function(o){return isConnected(o,d) ? 0.9:0.05});

							link
							.transition(500)
							.style("stroke-opacity", function(o) {
								return o.source === d || o.target === d ? 1 : 0.05;
							}) 
							.transition(500)
							.attr("marker-end", function(o) {
								return o.source === d || o.target === d ? "url(#arrowhead)" : "url()";
							});

							/*+++++++++++++++++
							 + Prepare synopsis
							 ++++++++++++++++++*/

							prepSynopsis(d); 
						}
					
					}); 
				}

			}; 


			/*+++++++++++++++++++++
			 + func: prepSynopsis()
			 ++++++++++++++++++++++*/

			function prepSynopsis(d){

				var dictTech = {'CMS': 'Content Management System', 'CRM': 'Customer Relationship Management', 'OTP': 'Online Testing Platforms', 'DNS': 'Domain Name Service', 'WPM': 'Web Performance Monitoring', 'ISP': 'Internet Services Provider'}; 
				var strDep = '';
				var depArray = [];
				var techArray = [];
				for (var key in links){
					var test = links[key];
					if (test['source'] === d){
						depArray.push('<TR><TD>' + test['label'] + '</TD><TD>' + test['target'].name + '</TD><TD>Vendor</TD></TR>'); 
						if(!techArray.includes(test['label'])){
							techArray.push(test['label']);
						}
					}
					else if (test['target'] === d){
						depArray.push('<TR><TD>' + test['label'] + '</TD><TD>' + test['source'].name + '</TD><TD>Customer</TD></TR>'); 
						if(!techArray.includes(test['label'])){
							techArray.push(test['label']);
						}
					}
				}	
				
				depArray = depArray.sort(); 
				techArray = techArray.sort(); 

				strDep += '<p align="center"><font face="sans-serif" size=3><b>' + d.name + '</b></font></p>';
				strDep += '<TABLE>' 
				for (var i = 0; i < depArray.length; i++){
					strDep += depArray[i]; 
				}
				strDep += '</TABLE><br>'
		
				var flagLegend = 0; 
				strLegend = '<font face="sans-serif" size=1.5><strong>Legend:</strong> <br>'
				for (var i = 0; i < techArray.length; i++){
					if (techArray[i] in dictTech){
						strLegend += techArray[i] + ': ' + dictTech[techArray[i]] + '<br>';
						flagLegend = 1; 	
						}
					} 

				strLegend += '</font>'; 
				
				if (flagLegend === 1){
					strDep += strLegend; 
				}
					
				var divSynopsis = document.getElementById('divSynopsis'); 
				divSynopsis.innerHTML = strDep;  
				divSynopsis.style.visibility = 'visible';
			}


			/*+++++++++++++++++++++++
			 + Graph data & drop-down
			 ++++++++++++++++++++++++*/
			
			var nodes = data.nodes; 
			var links = data.links; 

			var optArray = [];
			for (var i = 0; i < nodes.length; i++) {
				optArray.push(nodes[i].name);
			}

			optArray = optArray.sort();

			$(function () {
				$("#inpTxtTargetNode").autocomplete({
					source: optArray
				});
			});


			/*++++++++++++++++++
			 + Create SVG layout 
			 +++++++++++++++++++*/

			var width = 1200;
			var height = 700;

			var force = d3.layout.force()
			.nodes(nodes)
			.links(links)
			.charge(-200)
			.linkDistance(220)
			.linkStrength(0.01)
			.friction(0.8)
			.gravity(0.05)
			.size([width,height])
			.start();

			var linkedByIndex = {};
			links.forEach(function(d) {
				linkedByIndex[d.source.index + "," + d.target.index] = true;
			});

			var svg = d3.select("body").append("svg")
			.attr("width", width)
			.attr("height", height);

			var link = svg.selectAll("line")
			.data(links)
			.enter().append("line"); 

			var node = svg.selectAll(".node")
			.data(nodes)
			.enter().append("g")
			.attr("class", "node")
			.call(force.drag);

			node
			.append("circle")
			.attr("r", nodeRadius)
			.attr("fill", function(d){ return c10(d.size); })
			.on("mouseover", mouseOver)
			.on("mouseout", mouseOut); 


			/*+++++++++++++++++++++++++ 
			 + Font size for node label
			 ++++++++++++++++++++++++++*/

			node.append("text")
			.attr("x", 12)
			.attr("dy", ".35em")
			.attr("font-family", "sans-serif")
			.attr("font-size", function(d){ return 2 * nodeRadius(d); })
			.text(function(d) { return d.name; });

			
			node.append("title")
			.text(function(d) { return 'Ticker: ' + d.tooltip; });

			svg
			.append("marker")
			.attr("id", "arrowhead")
			.attr("refX", 6 + 7) // Controls the shift of the arrow head along the path
			.attr("refY", 2)
			.attr("markerWidth", 6)
			.attr("markerHeight", 4)
			.attr("orient", "auto")
			.append("path")
			.attr("d", "M 0,0 V 4 L6,2 Z")

			link
			.attr("marker-end", "url()");

			force.on("tick",tick);

			
		</script>

	</body>

	<div class="footer"><font size=4 color=#C0C0C0>&copy;netlabs.ai, 2018.</font></div>

</html>
